require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/meth/activities', type: :request do
  # Meth::Activity. As you add validations to Meth::Activity, be sure to
  # adjust the attributes here as well.
  # let(:valid_attributes) { skip('Add a hash of attributes valid for your model') }

  # let(:invalid_attributes) { skip('Add a hash of attributes invalid for your model') }
  let(:valid_attributes) { FactoryBot.attributes_for(:meth_activity) }
  let(:invalid_attributes) { FactoryBot.attributes_for(:meth_activity, name: '') }

  let(:user) { FactoryBot.create(:user) }
  let(:methodology) { FactoryBot.create(:methodology, :with_step_1) }
  # let(:step) { FactoryBot.create(:meth_step, methodology: methodology) }
  # let(:tool) { FactoryBot.create(:meth_tool) }

  before :each do
    user.set_session(:active_step_tool, methodology.steps.first.step_tools.first.id)
    user.save!
    sign_in user
  end

  describe 'GET /index' do
    it 'renders a successful response' do
      Meth::Activity.create! valid_attributes
      get meth_activities_url
      expect(response).to be_successful
    end
  end

  describe 'GET /show' do
    it 'renders a successful response' do
      meth_activity = Meth::Activity.create! valid_attributes
      get meth_activity_url(meth_activity)
      expect(response).to be_successful
    end
  end

  describe 'GET /new' do
    it 'renders a successful response' do
      get new_meth_activity_url
      expect(response).to be_successful
    end
  end

  describe 'GET /edit' do
    it 'render a successful response' do
      meth_activity = Meth::Activity.create! valid_attributes
      get edit_meth_activity_url(meth_activity)
      expect(response).to be_successful
    end
  end

  describe 'POST /create' do
    context 'with valid parameters' do
      it 'creates a new Meth::Activity' do
        expect {
          post meth_activities_url, params: { meth_activity: valid_attributes }
        }.to change(Meth::Activity, :count).by(1)
      end

      it 'redirects to the created meth_activity' do
        post meth_activities_url, params: { meth_activity: valid_attributes }
        expect(response).to redirect_to(meth_activity_url(@controller.instance_variable_get(:@activity)))
      end
    end

    context 'with invalid parameters' do
      it 'does not create a new Meth::Activity' do
        expect {
          post meth_activities_url, params: { meth_activity: invalid_attributes }
        }.to change(Meth::Activity, :count).by(0)
      end

      it "renders a successful response (i.e. to display the 'new' template)" do
        post meth_activities_url, params: { meth_activity: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe 'PATCH /update' do
    context 'with valid parameters' do
      let(:new_attributes) { {name: 'Activity new name'} }

      it 'updates the requested meth_activity' do
        meth_activity = Meth::Activity.create! valid_attributes
        patch meth_activity_url(meth_activity), params: { meth_activity: new_attributes }
        meth_activity.reload
        expect(meth_activity.name).to eq 'Activity new name'
      end

      it 'redirects to the meth_activity' do
        meth_activity = Meth::Activity.create! valid_attributes
        patch meth_activity_url(meth_activity), params: { meth_activity: new_attributes }
        meth_activity.reload
        expect(response).to redirect_to(meth_activity_url(meth_activity))
      end
    end

    context 'with invalid parameters' do
      it "renders a successful response (i.e. to display the 'edit' template)" do
        meth_activity = Meth::Activity.create! valid_attributes
        patch meth_activity_url(meth_activity), params: { meth_activity: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe 'DELETE /destroy' do
    it 'destroys the requested meth_activity' do
      meth_activity = Meth::Activity.create! valid_attributes
      expect {
        delete meth_activity_url(meth_activity)
      }.to change(Meth::Activity, :count).by(-1)
    end

    it 'redirects to the meth_activities list' do
      meth_activity = Meth::Activity.create! valid_attributes
      delete meth_activity_url(meth_activity)
      expect(response).to redirect_to(meth_activities_url)
    end
  end
end
